#include <SDL.h>
#include <SDL_thread.h>

#include "../pipes/streamPipe.h"
#include "streamElement.h"

StreamElement::StreamElement( StreamPipe* _in, StreamPipe* _out )
    : in( _in ), out( _out ), thr( 0 )
{
}

StreamElement::~StreamElement( void )
{
    if ( this->in not_eq 0 ) {
	this->in->readClose();
    }
    if ( this->out not_eq 0 ) {
	this->out->writeClose();
    }

    if ( this->thr not_eq 0 ) {
	this->waitForThread();
    }
}

void
StreamElement::startThread( void )
{
    this->thr = ::SDL_CreateThread( runTrampoline, this );
}

void
StreamElement::waitForThread( void )
{
    if ( this->thr not_eq 0 ) {
	int status;
	::SDL_WaitThread( this->thr, &status );
	this->thr = 0;
    }
}

int
StreamElement::runTrampoline( void* data )
{
    StreamElement* el = (StreamElement*)data;
    return el->run();
}
