
class StreamPipe {
public:
    StreamPipe( unsigned int _maxBufLen = 8192U );
    ~StreamPipe( void );

    int write( const void* src, unsigned int len );
    int read( void* src, unsigned int len );

    int rawWrite( const void* src, unsigned int len );
    int rawRead( void* src, unsigned int len );

    void writeClose( void );
    void readClose( void );

#ifdef TEST
    static int test( void );
#endif

private:
    int writeBytesCount( void ) const;
    int readBytesCount( void ) const;

    unsigned char* buffer;
    unsigned int maxBufLen;

    unsigned int curWriteIndex;
    unsigned int curReadIndex;

    SDL_mutex* mutex;
    SDL_cond* writeBytesAvailable;
    SDL_cond* readBytesAvailable;

    bool writeIsClosed;
    bool readIsClosed;
};
