
class StreamPipe;

class SoundDev : public StreamElement {

public:
    SoundDev(
	StreamPipe* in,
	unsigned int freq = 8192U, unsigned int channels = 1U,
	unsigned int samples = 8192U, double _gain = 1.0
    );
    ~SoundDev( void );

    unsigned int getFreq( void ) const;
    unsigned int getChannels( void ) const;

    void finish( void );

    inline static void
    callbackTrampoline( void* userData, Uint8* stream, int len ) {
	SoundDev* dev = (SoundDev*)userData;
	dev->callback( stream, len );
    };

protected:
    int run( void );

private:
    void callback( Uint8* stream, unsigned int len );

    SDL_AudioSpec obtained;
    bool gotAudio;

    double* inBuf;
    double gain;

    SDL_mutex* mutex;
    SDL_cond* finishedCond;
    bool isFinished;
};
